
#import "Neuron.h"

@implementation Neuron


- init
{
    [super init];

    neuroncount = 0;
    actualPosition = [[[NSMutableArray alloc] init] retain];
    tunnelDiode = [[[TunnelDiode alloc] init] retain];
    [self resetSimulator];
    return self;
}

-(void) dealloc
{
    free(timerofneuron);
    [actualPosition release];
    [tunnelDiode release];
    [super dealloc]; 
}

- (void)resetSimulator;
{
    NSMutableArray *xValues=[NSMutableArray array];
    NSMutableArray *yValues=[NSMutableArray array];

    free(timerofneuron);
    neuroncount=0;
    
    [actualPosition removeAllObjects];
    [xValues addObject:[NSNumber numberWithDouble:0.0]];
    [yValues addObject:[NSNumber numberWithDouble:0.0]];
    [actualPosition addObject:xValues];
    [actualPosition addObject:yValues];
}


- (NSArray *)differentialOf:(NSArray*)position;
{
    NSArray *xValues = [position objectAtIndex:0];
    NSArray *yValues = [position objectAtIndex:1];

    double timenow;
    double uknoten;
    double dknoten;
	
    double uneuron = [uNeuron doubleValue];
    double lambda1 = [lambda1Neuron doubleValue];
    double lambda2 = [lambda2Neuron doubleValue];

    double ineurons = 0.0;
    double itunnel = 0.0;
    int i;

    timenow = [[xValues objectAtIndex:0] doubleValue];
    uknoten = [[yValues objectAtIndex:0] doubleValue];
    
    if( 0 == neuroncount )
    {
        neuroncount = [rButtonmatrix numberOfRows];
        timerofneuron = (double*)malloc(sizeof(double)*neuroncount);
        for(i=0;i<neuroncount;i++)
        {
            timerofneuron[i] = -1.0;
        }
    }
    
    for(i=0;i<neuroncount;i++)
    {
        if( (timerofneuron[i]<0.0) && ([[rButtonmatrix cellAtRow:i column:0] state]) )
        {
            timerofneuron[i]=timenow;
        }
        if(timerofneuron[i]>-1.0)
        {
            double ufromneuron;

            ufromneuron = uneuron*(exp(-lambda1*(timenow-timerofneuron[i]))-exp(-lambda2*(timenow-timerofneuron[i])));
            ineurons += (ufromneuron-uknoten)/[[rValuematrix cellAtRow:i column:0] doubleValue];
       }
        else
        {
            ineurons -= uknoten/[[rValuematrix cellAtRow:i column:0] doubleValue];
        }
    }

    itunnel =[[tunnelDiode valueAt:[NSNumber numberWithDouble:uknoten]] doubleValue];
    dknoten = (   (([uBasis doubleValue]-uknoten)/[rBasis doubleValue])
                + ineurons
                - itunnel
               )/ [c1 doubleValue];

    return [NSMutableArray arrayWithObjects:[NSNumber numberWithDouble:dknoten],nil];
}


- (NSArray *)simulateOneStepWithIntegrator:(id <Integrator>) integrator delta:(NSNumber *)delta epsilon:(NSNumber *)epsilon;
{
	NSMutableArray *points=[NSMutableArray array];
	NSMutableArray *point0=[NSMutableArray array];
	NSMutableArray *xValues=[actualPosition objectAtIndex:0];
	double newTime;
	NSArray *newYValues;
	
	newYValues = [integrator integrate:self position:actualPosition delta:delta epsilon:epsilon];
	[actualPosition replaceObjectAtIndex:1 withObject:newYValues];
	
	newTime = [[xValues objectAtIndex:0] doubleValue] + [delta doubleValue];
	[xValues replaceObjectAtIndex:0 withObject:[NSNumber numberWithDouble:newTime]];

	[point0 addObject:[newYValues objectAtIndex:0]];
        [point0 addObject:[color0 color]];
	[points addObject:point0];

	return points;
}
@end
