
#import "RungeKutta.h"

@implementation RungeKutta

- (NSArray *)integrate:simulator position:(NSArray*)position delta:(NSNumber *)deltaObject epsilon:(NSNumber *)epsilon
{
    NSArray *xValues = [position objectAtIndex:0];
    NSArray *yValues = [position objectAtIndex:1];
    NSMutableArray *xMomentary = [[[NSMutableArray alloc] init] autorelease];
    NSMutableArray *yMomentary = [[[NSMutableArray alloc] init] autorelease];
    NSMutableArray *testPosition = [[[NSMutableArray alloc] init] autorelease];

    double delta=[deltaObject doubleValue];

    NSArray *k1,*k2,*k3,*k4;
    NSMutableArray *y = [[[NSMutableArray alloc] init] autorelease];

    int xCount = [xValues count];
    int yCount = [yValues count];
    int i;


    k1 = [simulator differentialOf:position];
	
	
    for(i=0;i<xCount;i++)
    {
        [xMomentary addObject:[NSNumber numberWithDouble:([[xValues objectAtIndex:i] doubleValue]
                                                          + ( delta / 2.0)) ] ];
    }
    for(i=0;i<yCount;i++)
    {
        [yMomentary addObject:[NSNumber numberWithDouble:([[yValues objectAtIndex:i] doubleValue]
                                                          + ((delta * [[k1 objectAtIndex:i] doubleValue] )/ 2.0))] ];
    }
    [testPosition removeAllObjects];	
    [testPosition addObject:xMomentary];
    [testPosition addObject:yMomentary];
    k2 = [simulator differentialOf:testPosition];



    [yMomentary removeAllObjects];
    for(i=0;i<yCount;i++)
    {
        [yMomentary addObject:[NSNumber numberWithDouble:([[yValues objectAtIndex:i] doubleValue]
                                                          + ((delta * [[k2 objectAtIndex:i] doubleValue]) / 2.0))]];
    }
    [testPosition removeAllObjects];	
    [testPosition addObject:xMomentary];
    [testPosition addObject:yMomentary];
    k3 = [simulator differentialOf:testPosition];



    [xMomentary removeAllObjects];
    [yMomentary removeAllObjects];
    for(i=0;i<xCount;i++)
    {
        [xMomentary addObject:[NSNumber numberWithDouble:([[xValues objectAtIndex:i] doubleValue]
                                                          + delta) ]];
    }
    for(i=0;i<yCount;i++)
    {
        [yMomentary addObject:[NSNumber numberWithDouble:([[yValues objectAtIndex:i] doubleValue]
                                                          + (delta * [[k3 objectAtIndex:i] doubleValue])) ]];
    }
    [testPosition removeAllObjects];	
    [testPosition addObject:xMomentary];
    [testPosition addObject:yMomentary];
    k4 = [simulator differentialOf:testPosition];
	
    for(i=0;i<yCount;i++)
    {
        [y addObject:[NSNumber numberWithDouble:[[yValues objectAtIndex:i] doubleValue]
                                                + (((delta *[[k1 objectAtIndex:i] doubleValue])
                                                +   (delta *[[k2 objectAtIndex:i] doubleValue] * 2 )
                                                +   (delta *[[k3 objectAtIndex:i] doubleValue] * 2 )
                                                +   (delta *[[k4 objectAtIndex:i] doubleValue]) ) / 6.0 )] ];
    /*	NSLog(@"RungeKutta[%d] k1:%f k2:%f k3:%f k4:%f y=%f ",i,
                                                                      [[k1 objectAtIndex:i] doubleValue],
                                                                      [[k2 objectAtIndex:i] doubleValue],
                                                                      [[k3 objectAtIndex:i] doubleValue],
                                                                      [[k4 objectAtIndex:i] doubleValue],
                                                                      [[y objectAtIndex:i] doubleValue]);
    */
    }
	return y;
}


@end
