
#import "Simulation1.h"

@implementation Simulation1


- init
{
	[super init];

	actualPosition = [[[NSMutableArray alloc] init] retain];
	[self resetSimulator];
	return self;
}


- (void)resetSimulator;
{
	NSMutableArray *xValues=[NSMutableArray array];
	NSMutableArray *yValues=[NSMutableArray array];
	
	[actualPosition removeAllObjects];
	[xValues addObject:[NSNumber numberWithDouble:0.0]];
	[yValues addObject:[NSNumber numberWithDouble:0.0]];
	[yValues addObject:[NSNumber numberWithDouble:0.0]];
	[actualPosition addObject:xValues];
	[actualPosition addObject:yValues];
}


- (NSArray *)differentialOf:(NSArray*)position;
{
	NSArray			*xValues = [position objectAtIndex:0];
	NSArray			*yValues = [position objectAtIndex:1];

	double uin;
	double uknoten0 = [[yValues objectAtIndex:0] doubleValue];
	double uknoten1 = [[yValues objectAtIndex:1] doubleValue];
	double dknoten0,dknoten1;
	
	uin = [uamplitude doubleValue] * sin( [omega doubleValue] * [[xValues objectAtIndex:0] doubleValue] );
	
	dknoten0 = (  ( (uin/[rsperr doubleValue]) * (1.0+exp([alpha doubleValue]*((uin/[uknick doubleValue])-1))) 
			     -( uknoten0/[rvor doubleValue])
			   ) / [cvor doubleValue]);
  	
	dknoten1 = (((uknoten0-uknoten1)/[rvor doubleValue]) - (uknoten1/[rlast doubleValue]) ) / [clast doubleValue];

	return [[[NSMutableArray alloc] initWithObjects:[NSNumber numberWithDouble:dknoten0],
													[NSNumber numberWithDouble:dknoten1],
													nil] autorelease];
}


- (NSArray *)simulateOneStepWithIntegrator:(id <Integrator>) integrator delta:(NSNumber *)delta epsilon:(NSNumber *)epsilon;
{
	NSMutableArray *points=[NSMutableArray array];
	NSMutableArray *point0=[NSMutableArray array];
	NSMutableArray *point1=[NSMutableArray array];
	NSMutableArray *xValues=[actualPosition objectAtIndex:0];
	double newTime;
	NSArray 	*newYValues;
	
	newYValues = [integrator integrate:self position:actualPosition delta:delta epsilon:epsilon];
	[actualPosition replaceObjectAtIndex:1 withObject:newYValues];
	
	newTime = [[xValues objectAtIndex:0] doubleValue] + [delta doubleValue];
	[xValues replaceObjectAtIndex:0 withObject:[NSNumber numberWithDouble:newTime]];

	[point0 addObject:[newYValues objectAtIndex:0]];
        [point0 addObject:[color0 color]];
	[points addObject:point0];

        [point1 addObject:[newYValues objectAtIndex:1]];
        [point1 addObject:[color1 color]];
	[points addObject:point1];
	return points;
}
@end
