
#import "Simulation3.h"

@implementation Simulation3


- init
{
	[super init];

	actualPosition = [[[NSMutableArray alloc] init] retain];
	[self resetSimulator];
	return self;
}


- (void)resetSimulator;
{
	NSMutableArray *xValues=[NSMutableArray array];
	NSMutableArray *yValues=[NSMutableArray array];
	
	[actualPosition removeAllObjects];
	[xValues addObject:[NSNumber numberWithDouble:0.0]];
	[yValues addObject:[NSNumber numberWithDouble:0.0]];
	[actualPosition addObject:xValues];
	[actualPosition addObject:yValues];
}


- (NSArray *)differentialOf:(NSArray*)position;
{
	NSArray			*xValues = [position objectAtIndex:0];
	NSArray			*yValues = [position objectAtIndex:1];

	double uin,idiode;
	double uknoten0 = [[yValues objectAtIndex:0] doubleValue];
	double dknoten0;
	
	uin = [unull doubleValue] + ([uamplitude doubleValue]*sin([omega doubleValue]*[[xValues objectAtIndex:0] doubleValue]));
	
	idiode = ([ustab doubleValue]/[rsperr doubleValue]) * 
			 (1.0+exp([alpha doubleValue]*(([ustab doubleValue]/[uknick doubleValue])-1)));
	
	dknoten0 = ( 	(([beta doubleValue]*[rtransistor doubleValue])/uin) + 
					idiode - (uknoten0/[rlast doubleValue])
				 ) / [ctransistor doubleValue];
  	
	return [NSMutableArray arrayWithObjects:[NSNumber numberWithDouble:dknoten0],nil];
}


- (NSArray *)simulateOneStepWithIntegrator:(id <Integrator>) integrator delta:(NSNumber *)delta epsilon:(NSNumber *)epsilon;
{
	NSMutableArray *points=[NSMutableArray array];
	NSMutableArray *point0=[NSMutableArray array];
	NSMutableArray *xValues=[actualPosition objectAtIndex:0];
	double newTime;
	NSArray 	*newYValues;
	
	newYValues = [integrator integrate:self position:actualPosition delta:delta epsilon:epsilon];
	[actualPosition replaceObjectAtIndex:1 withObject:newYValues];
	
	newTime = [[xValues objectAtIndex:0] doubleValue] + [delta doubleValue];
	[xValues replaceObjectAtIndex:0 withObject:[NSNumber numberWithDouble:newTime]];

	[point0 addObject:[newYValues objectAtIndex:0]];
        [point0 addObject:[color0 color]];
	[points addObject:point0];
	return points;
}
@end
