
#import "Wassertanks.h"

@implementation Wassertanks


- init
{
	[super init];

	actualPosition = [[[NSMutableArray alloc] init] retain];
	[self resetSimulator];
	return self;
}


- (void)resetSimulator;
{
	NSMutableArray *xValues=[NSMutableArray array];
	NSMutableArray *yValues=[NSMutableArray array];
	
	[actualPosition removeAllObjects];
	[xValues addObject:[NSNumber numberWithDouble:0.0]];
	[yValues addObject:[NSNumber numberWithDouble:0.0]];
	[yValues addObject:[NSNumber numberWithDouble:0.0]];
	[actualPosition addObject:xValues];
	[actualPosition addObject:yValues];
}


- (NSArray *)differentialOf:(NSArray*)position;
{
	//NSArray			*xValues = [position objectAtIndex:0];
	NSArray			*yValues = [position objectAtIndex:1];

	double hoehe0 = [[yValues objectAtIndex:0] doubleValue];
	double hoehe1 = [[yValues objectAtIndex:1] doubleValue];
	double dhoehe0,dhoehe1;

	double l = ([rohrquerschnitt doubleValue] * sqrt( 2.0 * [gravitation doubleValue])  ) / [grundflaeche doubleValue];	
	dhoehe0 = ([zufluss doubleValue] / [grundflaeche doubleValue]) -
			  ( l * sqrt( hoehe0 - hoehe1 ) );
	dhoehe1 = ( l * ( sqrt(hoehe0 - hoehe1) - sqrt(hoehe1) ) );

//	double l = ([rohrquerschnitt doubleValue]*[rohrquerschnitt doubleValue]*[gravitation doubleValue]) / ( [grundflaeche doubleValue] * [zufluss doubleValue]) ;
//	dhoehe0 = (l*(hoehe1-hoehe0)) + ([zufluss doubleValue]/[grundflaeche doubleValue]);
//	dhoehe1 = l*(hoehe0+(2*hoehe1)) ;

	return [[[NSMutableArray alloc] initWithObjects:[NSNumber numberWithDouble:dhoehe0],
													[NSNumber numberWithDouble:dhoehe1],
													nil] autorelease];
}


- (NSArray *)simulateOneStepWithIntegrator:(id <Integrator>) integrator delta:(NSNumber *)delta epsilon:(NSNumber *)epsilon;
{
	NSMutableArray *points=[NSMutableArray array];
	NSMutableArray *point0=[NSMutableArray array];
	NSMutableArray *point1=[NSMutableArray array];
	NSMutableArray *xValues=[actualPosition objectAtIndex:0];
	double newTime;
	NSArray 	*newYValues;
	
	newYValues = [integrator integrate:self position:actualPosition delta:delta epsilon:epsilon];
	[actualPosition replaceObjectAtIndex:1 withObject:newYValues];
	
	newTime = [[xValues objectAtIndex:0] doubleValue] + [delta doubleValue];
	[xValues replaceObjectAtIndex:0 withObject:[NSNumber numberWithDouble:newTime]];

	[point0 addObject:[newYValues objectAtIndex:0]];
        [point0 addObject:[color0 color]];
	[points addObject:point0];
	[point1 addObject:[newYValues objectAtIndex:1]];
        [point1 addObject:[color1 color]];
	[points addObject:point1];
	return points;
}
@end
